/* $Id: SearchGoogle.m,v 1.1.1.1 2003/04/24 19:14:02 _ Exp $ */
#import "SearchGoogle.h"

NSString *front_appname()
{
/*
  ProcessSerialNumber psn;
  CFStringRef name;
  NSString *ret;

  psn.highLongOfPSN = psn.lowLongOfPSN = kNoProcess;
  GetFrontProcess(&psn);
  CopyProcessName(&psn,&name);

  ret = [NSString stringWithString:(NSString *)name];
  CFRelease(name);
*/
  return [[[NSWorkspace sharedWorkspace] activeApplication] objectForKey:@"NSApplicationName"];
}

@implementation SearchGoogle
- (id) init
{
  if (self = [super init]) {
    NSDictionary *info = [[NSBundle mainBundle] infoDictionary];
    default_url = [info objectForKey:@"SGDefaultURL"];
    context_urls = [info objectForKey:@"SGContextURLs"];
  }

  return self;
}

- (NSURL *)apply_url:(NSString *)text
{
  CFMutableStringRef t;
  NSString *urlstr;
  NSURL *url;

  t = CFStringCreateMutable(NULL,0);
  CFStringAppend(t,(CFStringRef)text);
  CFStringTrimWhitespace(t);
  CFStringReplaceAll(t,CFURLCreateStringByAddingPercentEscapes(NULL,t,NULL,NULL,kCFStringEncodingUTF8));

  urlstr = [context_urls objectForKey:front_appname()];
  if (urlstr == nil)  urlstr = default_url;

  CFStringInsert(t,0,(CFStringRef)urlstr);

  url = [NSURL URLWithString:(NSString *)t];
  CFRelease(t);
  return url;
}

- (void)doSearchGoogle:(NSPasteboard *)pboard
    userData:(NSString *)data
    error:(NSString **)error
{
  NSString *pboardString;
  NSURL *url;
  NSArray *types;
  
  types = [pboard types];

  if (![types containsObject:NSStringPboardType] || !(pboardString = [pboard stringForType:NSStringPboardType])) {
    *error = NSLocalizedString(@"Error: couldn't create URL",
        @"pboard couldn't give string");
    return;
  }

  url = [self apply_url:pboardString];
  
  if (!url) {
    *error = NSLocalizedString(@"Error: couldn't create URL",
        @"appl_url failed");
  }
  
  [[NSWorkspace sharedWorkspace] openURL:url];
}
@end
